#!/bin/sh
. /etc/GNUstep/GNUstep.conf

function runtool {
local toolpath=${GNUSTEP_SYSTEM_TOOLS}/${1}

# Check whether the tool exists
if [ -x ${toolpath} ]
then
    # Check whether the tool is already running for this user
    if ! ps -U $(id -u) -o cmd --no-headers | grep -q "^${toolpath}\>"
    then
        ${toolpath}
    fi
fi
unset toolpath
}

if [ -d ${HOME}/${GNUSTEP_USER_DIR} ]
then

    # Start up the GNUstep Distributed Notification Center daemon
    runtool gdnc

    # Start up the GNUstep PasteBoard Server daemon, if we're running X
    [ ${DISPLAY} ] && runtool gpbs

    # Start up the GNUstep Sound daemon if we have portaudio sound
    if portaudiolib=$(/sbin/ldconfig -p | grep '^[[:space:]]*libportaudio.so[[:space:]]') \
       && [ -e $(echo ${portaudiolib} | sed 's/^.*=>[[:space:]]*\([^[:space:]]*\)$/\1/') ]
    then
        runtool gnustep_sndd
    fi
    unset portaudiolib


    # Run 'make_services' in background if possible. We run it in a subshell;
    # otherwise, shells with job control (like bash) output an annoying
    # message when make_services is done, while we want it to happen silently.

    [ -x "${GNUSTEP_SYSTEM_TOOLS}/make_services" ] \
      && ("${GNUSTEP_SYSTEM_TOOLS}/make_services" &)

fi
